' ==============================================================
'  EXEMPLE 1 : Cet exemple montre l'utilisation des fonctions
'     ListBox, de l'objet CptEntry et de le fentre rsultat 
'  Objectif :
'     Affiche la liste des comptes et ouvre le compte choisi
'     Utilise la fentre rsultat pour indiquer le compte ouvert
' ==============================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

' Dclaration de la procdure principale "Test"
Sub ex1_Test()
Dim P,C,X,E,Inf
VBW.ClearList ' On vide la ListBox
P=0 ' P contient le n d'ordre du compte (index ou position)
For Each E in VBW  ' Pour chaque CptEntry 
  ' On l'ajoute dans la ListBox avec sa position P si c'est un compte Ecritures
  if E.Type=vbwTypeEcr then VBW.AddListItem E.Key & " - " & E.LongName, P
  P=P+1
next
VBW.ListSelect 0 ' Slectionne le premier compte cr dans VBW
C=VBW.ListShow("Choisir un compte")  ' Demande  l'utilisateur de choisir
if C=-1 then MsgBox "Annul" : Exit Sub
' On rcupre la position du compte choisi
' C reprsente l'index de choix dans la ListBox
' P reprsente la position (n d'ordre ou index) du compte sauvegard avec AddListItem
P=VBW.GetListData(C)
' On ouvre le compte ayant le n d'ordre (index) P
set X = VBW.OpenCpt(VBW.Item(P).Key)
VBW.TitleStr="Rsultat des essais"
VBW.PrintEffect=vbwDouble+vbwCenter
VBW.Print "Essai"
VBW.DrawLine
VBW.PrintEffect=vbwNormal
' X.Entry est un objet de type CptEntry
VBW.Print "Compte : " & X.Entry.Key
VBW.Print "Nom complet : " & X.Entry.LongName
VBW.Print "Type de compte : " & X.Entry.Type
if X.Entry.IsOnMinitel then VBW.Print "Compte sur Minitel"
VBW.Print "Fichiers stocks dans : " & X.Entry.Path
if X.Entry.Type=vbwTypeEcr then
  VBW.Print "Infos du compte : "
  Set Inf=X.GetInfo()
  VBW.Print "  > Numro de compte : " & Inf.NumCpt
  VBW.Print "  > Nom de la banque : " & Inf.NomBanque
  VBW.Print "  > Monnaie : " & Inf.Monnaie
  if Inf.Interets then
    VBW.Print "  > Interts : " & Inf.Taux
  else
    VBW.Print "  > Pas d'interts"
  end if
  VBW.Print "  > Solde Minimum : " & Inf.SoldeMin
end if
' On ouvre une vue standard (critures) pour le compte
X.ShowView vbwViewNormal
' On libre le compte ce qui fermera le compte quand il n'y aura plus de vue ouverte
X.Close False
End Sub


' Dclaration de la procdure de lancement "Go"
Sub Go()
' On dclare un menu Test qui lance la procdure principale "Test"
VBW.DeleteMenu "Test Exemple 1"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Test Exemple 1","ex1_Test"
End Sub
