' =====================================================================
'  EXEMPLE 2 : Cet exemple montre l'utilisation des fonctions
'     ListBox et la lecture d'critures dans un compte (objet Cpt)
'  Objectif :
'     Pour l'ensemble des comptes selectionns par l'utilisateur
'     Utilise la fentre rsultat pour indiquer le total par catgorie
' =====================================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

' Procdure principale
Sub Cumul()
Dim C,P,E,NBCPT,SEL,NbCat
Dim Liste() ' Tableau dynamique
Redim Liste(3,VBW.Count) ' On dimentionne un tableau asse grand pour tous les comptes
' Note: Le tableau utilise 3 dimensions : 0 = Texte, 1 = Index, et 2 = Selection

' Phase 1 : On rempli le tableau Liste
P=0 ' N d'ordre dans le tableau Liste
For Each E in VBW  ' Pour chaque CptEntry 
  ' On l'ajoute dans la Liste avec sa position si c'est un compte Ecritures
  if E.Type=vbwTypeEcr then 
     Liste(0,P) = E.Key & " - " & E.LongName ' Texte de choix  afficher
     Liste(1,P) = VBW.ItemIndex(E.Key) ' On mmorise l'index de ce compte
     Liste(2,P) = false ' Par dfault aucun selectionn
     P=P+1
  end if
next
NBCPT = P ' On mmorise le nombre de comptes dans la liste

' Phase 2 : On affiche une ListBox avec la liste des comptes pour slection
C=0
do
  VBW.ClearList ' On vide la ListBox
  ' Le N d'index de compte =  -1 sera utilis pour terminer la selection
  VBW.AddListItem "[Slectionnez cette ligne quand termin]", -1
  for P = 0 to NBCPT-1
    ' On ajoute chaque compte dans la ListBox avec son tat de slection (X)
    if Liste(2,P) then SEL=" (X)" else SEL=" ( )" ' Selectionn ou non
    VBW.AddListItem Liste(0,P) & SEL, P
  next 
  VBW.ListSelect 0 ' Slectionne le 1er item entr soit la ligne de validation 
  ' Demande  l'utilisateur de choisir
  C=VBW.ListShow("Choisir les comptes  prendre en compte")
  if C=-1 then MsgBox "Annul" : Exit Sub
  ' On rcupre la position du compte choisi que l'on avait mmoris
  ' C reprsente l'index de choix dans la ListBox et P la position dans Liste
  P=VBW.GetListData(C)
  if (P<>-1) then Liste(2,P)=not Liste(2,P) ' On inverse la slection
' On continu tant que l'utilisateur n'a pas choisi la ligne reserve pour terminer
loop until P=-1 

' Phase 3 : On analyse chaque compte pour crer un tableau de catgorie (Cat)

VBW.TitleStr="Valeurs cumuls des Catgories"
VBW.PrintEffect=vbwNormal
VBW.Print "Liste des comptes analyses :"

' On traite chaque compte
Dim Cat(2,100) ' Maximum 100 Catgories sinon il y aura une erreur dans ce script
' 2 dimensions dans Cat : 0 = Nom catgorie et 1 = Valeur
NbCat=0 ' Pour l'instant le tableau des Cat est vide
' Pour chaque compte on analyse les critures
for P = 0 to NBCPT-1
  if Liste(2,P) then ' Si le compte est slectionn
        ' On Analyse les critures du compte pour remplir Cat
        TraiteCpt VBW.Item(Liste(1,P)).Key,Cat,NbCat
        ' On indique que l'on a trait ce compte
        VBW.Print Liste(0,P)
  end if
next 

' Phase 4 : On affiche le rsultat
VBW.DrawLine
for P = 0 to NbCat-1
  VBW.Print Cat(0,P) & " = " & Cat(1,P)
next
VBW.DrawLine
' On libre la fentre rsultat pour ne plus qu'elle soit modifie
VBW.DiscardPrintOut False ' Pas de fermerture de la fentre
End Sub

' Procedure qui traite un compte pour en lire les critures et ajouter les
' nouvelles catgories dans Cat et/ou modifier le montant  la catgorie
' Key = Cl du compte  traiter , Cat = Tableau  remplir, NbCat = Nbre d'item dans Cat
sub TraiteCpt(ByVal Key, ByRef Cat, ByRef NbCat)
Dim CPT,An,MasterCat
An=2001 ' Anne  traiter (fixe dans l'exemple)
MasterCat=""
' On ouvre le compte
set CPT = VBW.OpenCpt(Key)
' On ouvre un query pour l'anne complete dans les previsions
CPT.NewQuery "01/01/" & An,"31/12/" & An,"NoPrev"
' Pour chaque criture on ajoute le montant  la catgorie
' Note : Les sous critures oblige un ajustement de l'criture principale dont
' la catgorie ne doit alors pas intgrer la totalit du montant 
while CPT.ReadNextEcr()
   ' On traite la catgorie et le montant de l'criture
   AddCat Cat,NbCat,CPT.Ecr.Cat,CPT.Ecr.Value
   if CPT.Ecr.TypeOpe=vbwOpeSec then
        ' sous ecritures....
        ' On ajuste la catgorie de l'criture principale
        AddCat Cat,NbCat,MasterCat,-CPT.Ecr.Value
   else
        ' Ecritures normales
        ' Sauvegarde la catgorie en cas de sous criture
        MasterCat=CPT.Ecr.Cat
   end if
wend
' On ferme le compte si pas de vue ouverte
CPT.Close False
End Sub

sub AddCat(ByRef Cat, ByRef NbCat, ByVal NomCat, ByVal Mont)
Dim P
For P=0 to NbCat-1
  if Cat(0,P)=NomCat then Cat(1,P)=Cat(1,P)+Mont : exit sub
next
' On ajoute car n'existe pas
Cat(0,NbCat)=NomCat
Cat(1,nbCat)=Mont
NbCat=NbCat+1
end Sub

Sub Go()
VBW.DeleteMenu "Cumul par catgorie"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Cumul par catgorie","Cumul"
End Sub
