' ==============================================================
'  EXEMPLE 3bis : Cet exemple montre l'utilisation d'un objet
'     UsrCpt pour afficher des lments et la modification d'criture
'     C'est une variante de l'exemple 3 qui utilise la boite de dialogue
'     d'dition d'une criture au lieu de juste demand un nouveau montant
'  Objectif :
'     Affiche la liste des comptes et ouvre le compte choisi
'     Utilise une fentre UsrCpt pour lister les critures du mois
'     Permet la modification d'une criture de la liste
' ==============================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

' Dclaration de la procdure principale "Test"
Sub ex3_Test()
Dim P,C,X,E
' Choix d'un compte
VBW.ClearList ' On vide la ListBox
P=0 ' P contient le n d'ordre du compte (index ou position)
For Each E in VBW  ' Pour chaque CptEntry 
  ' On l'ajoute dans la ListBox avec sa position P si c'est un compte Ecritures
  if E.Type=vbwTypeEcr or E.Type=vbwTypeAct then VBW.AddListItem E.Key & " - " & E.LongName, P
  P=P+1
next
VBW.ListSelect 0 ' Slectionne le premier compte cr dans VBW
C=VBW.ListShow("Choisir un compte")  ' Demande  l'utilisateur de choisir
if C=-1 then MsgBox "Annul" : Exit Sub
' On rcupre la position du compte choisi
' C reprsente l'index de choix dans la ListBox
' P reprsente la position (n d'ordre ou index) du compte sauvegard avec AddListItem
P=VBW.GetListData(C)
' On ouvre le compte pour le n d'ordre (index) : P
ex3_OpenUsr VBW.Item(P).Key
End sub

Sub ex3_OpenUsr(byval Key)
Dim USR,Mois,UsedCpt
Mois=Month(Now) & "/" & Year(Now)
' On ouvre un nouveau compte utilisateur pour l'affichage
SET USR=VBW.NewUsrCpt()
' On indique que l'utilisateur ne pourra fermer ni le compte (Fichier | Fermer compte), ni
' l'application VBW tant que l'on utilise le compte utilisateur (c'est pas obligatoire)
USR.Busy=True 
' On ouvre le compte ayant la cl Key
Set UsedCpt = USR.AttachCpt(Key)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Key)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
USR.SetHeader 0,28,"M", vbwColSymbol
USR.SetHeader 1,80,"Date"
USR.SetHeader 2,100,"Libell",vbwColLeft
USR.SetHeader 3,90,"Montant", vbwColRight
USR.SetHeader 4,80,"Cat", vbwColLeft
USR.TitleStr="Liste des critures de " & UsedCpt.Entry.LongName
USR.AutoSizeHdr=2  ' La colonne 2 sera ajuste selon la taille de la fentre
' Initialise la zone info avec deux lignes d'information
USR.SetInfo 0,"Pas de modifications effectues"
USR.SetInfo 1,"" ' Sera modifi plus tard
' On stocke le mois et le compte utilis
' Il est prfrable d'utiliser les zones mmoires du UsrCpt plutot que
' des variables globales pour viter les effets de bords si plusieurs 
' appels sont effectus  cette procdure sans refermer le compte
USR.SetMem 0,Mois
USR.SetMem 1,UsedCpt.Entry.Key
' On indique que la zone dtails (infos) doti tre affiche
USR.ShowDetails=True
' On prcise que en cas de demande de raffraichissmeent il faut appeller Updt
USR.SubRefresh="ex3_Updt"
' On prcise que en cas de demande de Filtre entre date il faut appeller ChangeDate
USR.SubFilterDate="ex3_ChangeDate"
' On indique un Menu d'activation avec sa macro "Edit"
USR.SubActivate="ex3_Edit"
USR.MenuActivate="Editer criture"
' On prcise que en cas de demande de nouvelle vue il faut appeller NewView
USR.SubNewView="ex3_NewView"
' On insre tous les items du compte (voir plus loin)
AddItemFrom UsedCpt,USR,Mois
' On affiche la fentre rsultat
USR.ShowView
' On libre le compte Utilisateur ce qui fermera le compte quand il n'y aura plus de vue ouverte
USR.Close False
' On libre le compte ce qui fermera le compte quand il n'y aura plus de vue ouverte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
End Sub

' Procdure charge d'entrer dans Usr toutes les critures de UsedCpt pour le Mois
sub AddItemFrom(byref UsedCpt, byref USR,  byval Mois)
Dim Pos
USR.SetInfo 1,"Mois affich : "  & Mois
' On ouvre un query pour le mois en cours
UsedCpt.NewQuery "01/" & Mois,"31/" & Mois,""
' Pour chaque criture on ajoute  USR
while UsedCpt.ReadNextEcr()
   Pos=USR.AddData(UsedCpt.Ecr.Key) ' On stocke la cl pour l'dition
   ex3_SetItemData UsedCpt.Ecr,USR,Pos
wend
end sub

' Modification pour une ECR dans POS
Sub ex3_SetItemData(byref Ecr,byref USR,Pos)
dim X
   Select Case Ecr.ModeOpe
       Case vbwModeRel X=vbwSymbolCheck
       Case vbwModePrv X="&"
       Case vbwModeBud X="0"
       Case Else X=" "
   End Select
   if Ecr.TypeOpe=vbwOpeSec then X=chr(216)
   USR.SetData Pos,0,X
   USR.SetData Pos,1,Ecr.DateVal
   if Ecr.TypeOpe=vbwOpeSec then 
      USR.SetData Pos,2,"   > " & Ecr.Text
      ' Couleur spcifique pour les sous critures
      USR.SetColor Pos,1
   else
      USR.SetData Pos,2,Ecr.Text
      USR.SetColor Pos,0
   end if
   ' Fixe une couleur unique  tout les enregistrement rapprochs
   if Ecr.ModeOpe=vbwModeRel then USR.SetColor Pos,4
   USR.SetData Pos,3,VBW.FormatNumber(Ecr.Value)
   USR.SetData Pos,4,Ecr.Cat
end sub

' Procedure qui sera appelle si l'utilisateur demande une mise  jour de l'affichage
sub ex3_Updt()
Dim UsedCpt,Nom,USR
' On rcupre le compte utilisaeur en cours
Set USR=VBW.LastUsrDoc
Nom=USR.GetMem(1) 'Mem 1 = Cl du Cpt
' On ouvre le compte associ
Set UsedCpt = USR.AttachCpt(Nom)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Nom)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
USR.Purge ' On supprimer toutes les donnes
' On insre tous les items du compte
AddItemFrom UsedCpt,USR,USR.GetMem(0) ' Mem 0 = Mois
' On signale les modifications
USR.NotifyChange True
' On libre le compte ce qui fermera le compte quand il n'y aura plus de vue ouverte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
end sub

' Procedure qui sera appelle si l'utilisateur demande un filtre entre date
sub ex3_ChangeDate()
Dim USR,Mois,P,MM,MA
' On rcupre le compte utilisateur concern
Set USR=VBW.LastUsrDoc
Mois=USR.GetMem(0) 'Mem 0 = Mois
Mois=InputBox("Entre le mois et l'anne (MM/AAAA) :","Filtre entre date",Mois)
P=InStr(1,Mois,"/")
if P>1 then MM=left(Mois,P-1) else MM=Mois
if not IsNumeric(MM) then MM=Month(Now)
if MM>12 or MM<1 then MM=Month(Now)
if P>0 then MA=MID(Mois,P+1) else MA=Year(Now)
if not IsNumeric(MA) then MA=Year(Now)
if MA<1 then MA=Year(Now)
if MA<100 then MA=MA+2000
Mois=MM & "/" & MA
USR.SetMem 0,Mois
' On fait une mise  jour
ex3_Updt
end sub

' Dclaration de la procdure d'dition d'une criture
sub ex3_Edit()
Dim Pos,Key,USR,Lib,Nom,UsedCpt
' On rcupre le compte utilisateur concern
SET USR = VBW.LastUsrDoc()
' La ligne concerne
Pos=USR.Selected
' Le libell stock en colonne 2
Lib=USR.GetData(Pos,2)
' La cl stocke
Key=USR.GetDataKey(Pos)
' On indique dans la zone dtail
USR.SetInfo 0,"Dernire modification sur : " & Lib 
Nom=USR.GetMem(1) 'Mem 1 = Cl du Cpt
' On ouvre le compte associ
Set UsedCpt = USR.AttachCpt(Nom)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Nom)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
' On prpare la boite de dialogue
UsedCpt.EcrDialog.Reset()
UsedCpt.EcrDialog.Write=false
UsedCpt.EcrDialog.DecBud=false
UsedCpt.EcrDialog.EnableDecBud=true
' On dite l'criture
if not UsedCpt.EditEcrDialog(Key) then ' En cas d'erreur on annule
    UsedCpt.Close False ' On libre le compte
    USR.SetInfo 0,"Modification annule sur : " & Lib
    USR.NotifyChange false
    Exit Sub
end if
MsgBox UsedCpt.EcrDialog.Ecr.Text & " - " & UsedCpt.EcrDialog.DecBud
' On signale les changements avec reload partiel
UsedCpt.ReadEcrAt Key
ex3_SetItemData UsedCpt.Ecr,USR,Pos
USR.NotifyChange false
' On libre le compte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
end sub

' Procedure qui sera appelle si l'utilisateur demande une nouelle vue
sub ex3_NewView()
Dim USR,Key,Rep
' On rcupre le compte utilisateur concern
SET USR = VBW.LastUsrDoc()
' La cl stocke
Key=USR.GetMem(1) 'Mem 1 = Cl du Cpt
Rep=MsgBox("Ouvrir une vue indpendante ?", vbYesNoCancel, "Nouvelle vue")
if Rep=vbCancel then Exit Sub
if Rep=vbYes then
   ' On ouvre un nouveau
   ex3_OpenUsr Key
else
   ' On affiche juste une nouvelle vue (= action standard sans macro)
   USR.ShowView
end if
end sub


' Dclaration de la procdure de lancement "Go"
Sub Go()
' On dclare un menu Test qui lance la procdure principale "Test"
VBW.DeleteMenu "Test Exemple 3"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Test Exemple 3","ex3_Test"
End Sub
