' ==============================================================
'  EXEMPLE 6 : Cet exemple montre l'utilisation d'un objet Budget
'     pour afficher et modifier des critures du budget
'  Objectif :
'     Affiche la liste des critures en mode budget du budget pour
'     le compte ouvert (qui doit tre du type critues).
' ==============================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

' Dclaration de la procdure principale "Test"
Sub ex6_Test()
Dim USR,CPT,Pos,Ecr,Key,EM,E,M,Mont
if not IsObject(VBW.LastDoc())  then
  MsgBox "Erreur aucun compte ouvert"
  Exit sub
end if
set CPT = VBW.LastDoc()
if not CPT.Entry.Type=vbwTypeEcr then
  MsgBox "Erreur le compte " & CPT.Entry.Key & " n'est pas un compte Ecritures"
  Exit sub
end if
' On ouvre un nouveau compte utilisateur pour l'affichage
SET USR=VBW.NewUsrCpt()
Key = CPT.Entry.Key
' On ouvre le compte ayant la cl Key
Set CPT = USR.AttachCpt(Key)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Key)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
USR.SetHeader 0,28,"M", vbwColSymbol
USR.SetHeader 1,80,"Catgorie"
USR.SetHeader 2,100,"Budget",vbwColLeft
USR.SetHeader 3,90,"Montant", vbwColRight
USR.SetHeader 4,80,"Cat Pr", vbwColLeft
USR.SetHeader 5,150,"Catgorie Principale", vbwColLeft
USR.TitleStr="Liste des budget de " & CPT.Entry.LongName
USR.AutoSizeHdr=2  ' La colonne 2 sera ajuste selon la taille de la fentre
' On stocke le compte utilis
' Il est prfrable d'utiliser les zones mmoires du UsrCpt plutot que
' des variables globales pour viter les effets de bords si plusieurs 
' appels sont effectus  cette procdure sans refermer le compte
USR.SetMem 0,CPT.Entry.Key
' On indique que la zone dtails (infos) ne doit pas tre affiche
USR.ShowDetails=False
' On indique un Menu d'activation avec sa macro "Edit"
USR.SubActivate="ex6_Edit"
USR.MenuActivate="Editer budget"
' On prcise que en cas de clic sur un en-tete de colonne il faut appeller HeaderClic
USR.SubHeader="ex6_HeaderClic"
' On slectione la macro  lancer lors d'un clic dans la 1er colonne
USR.SubCheck="ex6_Checked"
for Each E in CPT.Budget 
   Key=E.FirstEcrKey
   do while (Key<>-1)
      set Ecr=CPT.GetBudgetEcr(Key)
      if Ecr.IsBudget then  ' On a trouv une criture de type budget
        Pos=USR.AddData(Ecr.Key) ' On stocke la cl pour l'dition
        ' On rempli les champs
        if E.HasSubCat then USR.SetData Pos,0,"4"
        if E.MasterCat<>"" then
            USR.SetData Pos,0,"!"
            set EM=CPT.GetBudgetEntry(E.MasterCat)
            USR.SetData Pos,4,E.MasterCat ' = EM.Key
            USR.SetData Pos,5,EM.LongName
        end if
        USR.SetData Pos,1,E.Key
        USR.SetData Pos,2,E.LongName
        Mont=0
        for M = 1 to 12 
          Mont=Mont+Ecr.GetMonth(M)
        next
        USR.SetData Pos,3,VBW.FormatNumber(Mont)
      end if
      ' On se positionne pour lire l'criture suivante
      Key=Ecr.NextEcrKey
   loop
next
' On affiche la fentre rsultat
USR.ShowView
' On libre le compte Utilisateur ce qui fermera le compte quand il n'y aura plus de vue ouverte
USR.Close False
' On libre le compte ce qui fermera le compte quand il n'y aura plus de vue ouverte
CPT.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
End sub

' Procedure qui sera appelle si l'utilisateur clique sur la 1er colonne
sub ex6_Checked()
Dim USR,Pos,E,UsedCpt,Nom,Cat,C,Key
' On rcupre le compte utilisaeur en cours
Set USR=VBW.LastUsrDoc
Pos=USR.Selected ' Ligne clique
Cat=USR.GetData(Pos,1) ' On rcupre la catgorie
Nom=USR.GetMem(0) 'Mem 0 = Cl du Cpt
' On ouvre le compte associ
Set UsedCpt = USR.AttachCpt(Nom)
VBW.ClearList ' On vide la ListBox
for each E in UsedCpt.Budget
  if E.MasterCat="" then VBW.AddListItem E.Key & " - " & E.LongName
next
VBW.AddListItem "[Aucune]"
C=VBW.ListShow("Choisir une nouvelle catgorie principale pour " & Cat)
if C<>-1 then 
        Key=VBW.GetListItem(C) ' Affecte Catgorie dans Key
        set E=UsedCpt.GetBudgetEntry(Cat)
        Nom=E.MasterCat
        if Key="[Aucune]" then
          if not UsedCpt.Budget.ChangeMaster(Cat,"") then Exit Sub    
          USR.SetData Pos,4, ""
          USR.SetData Pos,5, ""
          USR.SetData Pos,0,""
          if E.HasSubCat then USR.SetData Pos,0,"4"
        else
          C=InStr(Key,"-")
          Key=left(Key,C-2)
          if not UsedCpt.Budget.ChangeMaster(Cat,Key) then Exit Sub    
          USR.SetData Pos,4, Key
          ' On rcupre la budget de la catgotrie principale
          set E=UsedCpt.GetBudgetentry(Key)
          USR.SetData Pos,5,E.LongName
          USR.SetData Pos,0,"!"
          ' On met  jour la nouvelle catgorie principale
          C=USR.FindData(1,Key)
          USR.SetData C,0,"" ' On efface l'indicateur pour le repositionner
          if E.HasSubCat then USR.SetData C,0,"4"
          if E.MasterCat<>"" then USR.SetData C,0,"!"
        end if
        if Nom<>"" then C=USR.FindData(1,Nom) else C=-1
        if C<>-1 then 
            ' On recherche l'ancienne catgorie principale pour modifier l'affichage
            set E=UsedCpt.GetBudgetentry(Nom)
            USR.SetData C,0,"" ' On efface l'indicateur pour le repositionner
            if E.HasSubCat then USR.SetData C,0,"4"
            if E.MasterCat<>"" then USR.SetData C,0,"!"
        end if
        ' On signale les changements (pas de reload le nbre d'item n'est pas modifi)
        USR.NotifyChange false
end if
' On libre le compte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
end sub

' Procedure qui sera appelle si l'utilisateur clique sur un en-tete de colonne
sub ex6_HeaderClic()
Dim USR,Item,Rech,Pos
' On rcupre le compte utilisaeur en cours
Set USR=VBW.LastUsrDoc
Item=USR.HeaderClicked ' En tete cliqu
Rech=InputBox("Entrez une valeur de recherche :","Chercher...","")
if Rech="" then Exit Sub
Pos=USR.FindData(Item,Rech)
if (Pos>-1) then
  MsgBox "Existe en ligne " & Pos
  USR.ViewSelect Pos
else
  MsgBox "Introuvable"
end if
end sub

' Dclaration de la procdure d'dition d'une criture
sub ex6_Edit()
Dim Pos,Key,USR,Nom,UsedCpt,Ecr,C,Mont,Neg,Lib,E
' On rcupre le compte utilisateur concern
SET USR = VBW.LastUsrDoc()
' La ligne concerne
Pos=USR.Selected
' La cl stocke
Key=USR.GetDataKey(Pos)
Nom=USR.GetMem(0) 'Mem 0 = Cl du Cpt
' On ouvre le compte associ
Set UsedCpt = USR.AttachCpt(Nom)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Nom)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
set Ecr=UsedCpt.GetBudgetEcr(Key)
Neg=false ' A priori pas de nombre ngatif
for C=1 to 12 
  if Ecr.GetMonth(C)<0 then Neg=true ' Le budget est ngatif
next
do
  VBW.ClearList ' On vide la ListBox
  VBW.AddListItem "Valider les modifications de " & Ecr.Cat, 15
  VBW.AddListItem "Libell : " & Ecr.Lib, 0
  VBW.AddListItem " 1 - Janvier : " & VBW.FormatNumber(Ecr.GetMonth(1)), 1
  VBW.AddListItem " 2 - Fvrier : " & VBW.FormatNumber(Ecr.GetMonth(2)), 2
  VBW.AddListItem " 3 - Mars : " & VBW.FormatNumber(Ecr.GetMonth(3)), 3
  VBW.AddListItem " 4 - Avril : " & VBW.FormatNumber(Ecr.GetMonth(4)), 4
  VBW.AddListItem " 5 - Mai : " & VBW.FormatNumber(Ecr.GetMonth(5)), 5
  VBW.AddListItem " 6 - Juin : " & VBW.FormatNumber(Ecr.GetMonth(6)), 6
  VBW.AddListItem " 7 - Juillet : " & VBW.FormatNumber(Ecr.GetMonth(7)), 7
  VBW.AddListItem " 8 - Aot : " & VBW.FormatNumber(Ecr.GetMonth(8)), 8
  VBW.AddListItem " 9 - Septembre : " & VBW.FormatNumber(Ecr.GetMonth(9)), 9
  VBW.AddListItem "10 - Ocotbre : " & VBW.FormatNumber(Ecr.GetMonth(10)), 10
  VBW.AddListItem "11 - Novembre : " & VBW.FormatNumber(Ecr.GetMonth(11)), 11
  VBW.AddListItem "12 - Dcembre : " & VBW.FormatNumber(Ecr.GetMonth(12)), 12
  VBW.ListSelect 0 ' Slectionne le premier choix
  ' Demande  l'utilisateur de choisir une option
  C=VBW.ListShow("Choisir un item  modifier")
  if C<>-1 then C=VBW.GetListData(C)
  if C>0 and C<13 then
     Mont=VBW.FormatNumber(Ecr.GetMonth(C))
     Mont=InputBox("Entrez une nouvelle valeur :","Edition criture",Mont)
     if not IsEmpty(Mont) then 
        ' On transforme le texte en nombre
        Mont=VBW.EvalNumber(CStr(Mont))
        if (Mont<0)<>Neg and Mont<>0 then
          MsgBox "Impossible de changer de signe le budget",vbOkOnly,"Erreur"
        else
          Ecr.SetMonth C,Mont
        end if
     end if
  end if
  if C=0 then
     Lib=Ecr.Lib
     Lib=InputBox("Entrez un nouveau libell :","Edition criture",Lib)
     if Lib<>"" then Ecr.Lib=Lib
  end if
loop while C<>-1 and C<>15
if C<>-1 then 
  UsedCpt.SetBudgetEcr Ecr
  Mont=0
  for C = 1 to 12 
    Mont=Mont+Ecr.GetMonth(C)
  next
  USR.SetData Pos,3,VBW.FormatNumber(Mont)
  ' On signale les changements (pas de reload le nbre d'item n'est pas modifi)
  USR.NotifyChange false
end if
' On libre le compte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
end sub

' Dclaration de la procdure de lancement "Go"
Sub Go()
' On dclare un menu Test qui lance la procdure principale "Test"
VBW.DeleteMenu "Test Exemple 6"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Test Exemple 6","ex6_Test"
End Sub
