' ==============================================================
'  Editer Libell spcifique d'un compte titre
'  Objectif :
'     Affiche la liste des comptes Titre et ouvre le compte choisi
'     Permet de modifier le libell spcifique d'une opration
' ==============================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

' Dclaration de la procdure principale "Test"
Sub edtact_Run()
Dim P,C,X,E
' Choix d'un compte
VBW.ClearList ' On vide la ListBox
P=0 ' P contient le n d'ordre du compte (index ou position)
For Each E in VBW  ' Pour chaque CptEntry 
  ' On l'ajoute dans la ListBox avec sa position P si c'est un compte Titre
  if E.Type=vbwTypeAct then VBW.AddListItem E.Key & " - " & E.LongName, P
  P=P+1
next
VBW.ListSelect 0 ' Slectionne le premier compte cr dans VBW
C=VBW.ListShow("Choisir un compte")  ' Demande  l'utilisateur de choisir
if C=-1 then MsgBox "Annul" : Exit Sub
' On rcupre la position du compte choisi
' C reprsente l'index de choix dans la ListBox
' P reprsente la position (n d'ordre ou index) du compte sauvegard avec AddListItem
P=VBW.GetListData(C)
' On ouvre le compte pour le n d'ordre (index) : P
edtact_OpenUsr VBW.Item(P).Key
End sub

Sub edtact_OpenUsr(byval Key)
Dim USR,Mois,UsedCpt
Mois=Month(Now) & "/" & Year(Now)
' On ouvre un nouveau compte utilisateur pour l'affichage
SET USR=VBW.NewUsrCpt()
' On indique que l'utilisateur ne pourra fermer ni le compte (Fichier | Fermer compte), ni
' l'application VBW tant que l'on utilise le compte utilisateur (c'est pas obligatoire)
' Le seul but est d'viter un "plantage" de VBW lors d'un accs au compte attach
' si quelqu'un a utilis le menu Fichier | Fermer compte sur un des comptes attachs.... 
USR.Busy=True 
' On ouvre le compte ayant la cl Key
Set UsedCpt = USR.AttachCpt(Key)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Key)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
USR.SetHeader 0,30,"NL", vbwColLeft
USR.SetHeader 1,80,"Date", vbwColCenter
USR.SetHeader 2,120,"Action",vbwColLeft
USR.SetHeader 3,90,"Montant", vbwColRight
USR.SetHeader 4,100,"Libell", vbwColLeft
USR.TitleStr="Liste des critures de " & UsedCpt.Entry.LongName
USR.AutoSizeHdr=4  ' La colonne 4 sera ajuste selon la taille de la fentre
' Initialise la zone info avec deux lignes d'information
USR.SetInfo 0,"Pas de modifications effectues"
USR.SetInfo 1,"" ' Sera modifi plus tard
' On stocke le mois et le compte utilis
' Il est prfrable d'utiliser les zones mmoires du UsrCpt plutot que
' des variables globales pour viter les effets de bords si plusieurs 
' appels sont effectus  cette procdure sans refermer le compte
USR.SetMem 0,Mois
USR.SetMem 1,UsedCpt.Entry.Key
' On indique que la zone dtails (infos) doti tre affiche
USR.ShowDetails=True
' On prcise que en cas de demande de raffraichissmeent il faut appeller Updt
USR.SubRefresh="edtact_Updt"
' On prcise que en cas de demande de Filtre entre date il faut appeller ChangeDate
USR.SubFilterDate="edtact_ChangeDate"
' On indique un Menu d'activation avec sa macro "Edit"
USR.SubActivate="edtact_Edit"
USR.MenuActivate="Editer criture"
' On insre tous les items du compte (voir plus loin)
AddItemFrom UsedCpt,USR,Mois
' On affiche la fentre rsultat
USR.ShowView
' On libre le compte Utilisateur ce qui fermera le compte quand il n'y aura plus de vue ouverte
USR.Close False
' On libre le compte ce qui fermera le compte quand il n'y aura plus de vue ouverte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
End Sub

' Procdure charge d'entrer dans Usr toutes les critures de UsedCpt pour le Mois
sub AddItemFrom(byref UsedCpt, byref Usr,  byval Mois)
Dim Pos,X
USR.SetInfo 1,"Mois affich : "  & Mois
' On ouvre un query pour le mois en cours
UsedCpt.NewQuery "01/" & Mois,"31/" & Mois,""
' Pour chaque criture on ajoute  USR
while UsedCpt.ReadNextEcr()
   Pos=USR.AddData(UsedCpt.Ecr.Key) ' On stocke la cl pour l'dition
   X=UsedCpt.Ecr.ModeOpe
   USR.SetData Pos,0,X
   USR.SetData Pos,1,UsedCpt.Ecr.DateVal
   USR.SetData Pos,2,UsedCpt.Ecr.Text
   USR.SetColor Pos,0
   ' Fixe une couleur unique  tout les libells spcifiques
   if UsedCpt.Ecr.ModeOpe>0 then USR.SetColor Pos,1
   USR.SetData Pos,3,VBW.FormatNumber(UsedCpt.Ecr.Value)
   USR.SetData Pos,4,UsedCpt.Ecr.NameOpe
wend
end sub

' Procedure qui sera appelle si l'utilisateur demande une mise  jour de l'affichage
sub edtact_Updt()
Dim UsedCpt,Nom,USR
' On rcupre le compte utilisaeur en cours
Set USR=VBW.LastUsrDoc
Nom=USR.GetMem(1) 'Mem 1 = Cl du Cpt
' On ouvre le compte associ
Set UsedCpt = USR.AttachCpt(Nom)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Nom)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
USR.Purge ' On supprimer toutes les donnes
' On insre tous les items du compte
AddItemFrom UsedCpt,USR,USR.GetMem(0) ' Mem 0 = Mois
' On signale les modifications
USR.NotifyChange(True)
' On libre le compte ce qui fermera le compte quand il n'y aura plus de vue ouverte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
end sub

' Procedure qui sera appelle si l'utilisateur demande un filtre entre date
sub edtact_ChangeDate()
Dim USR,Mois,P,MM,MA
' On rcupre le compte utilisateur concern
Set USR=VBW.LastUsrDoc
Mois=USR.GetMem(0) 'Mem 0 = Mois
Mois=InputBox("Entre le mois et l'anne (MM/AAAA) :","Filtre entre date",Mois)
P=InStr(1,Mois,"/")
if P>1 then MM=left(Mois,P-1) else MM=Mois
if not IsNumeric(MM) then MM=Month(Now)
if MM>12 or MM<1 then MM=Month(Now)
if P>0 then MA=MID(Mois,P+1) else MA=Year(Now)
if not IsNumeric(MA) then MA=Year(Now)
if MA<1 then MA=Year(Now)
if MA<100 then MA=MA+2000
Mois=MM & "/" & MA
USR.SetMem 0,Mois
' On fait une mise  jour
edtact_Updt
end sub

' Dclaration de la procdure d'dition d'une criture
sub edtact_Edit()
Dim Pos,Key,USR,Lib,LibNum,LibTxt,Nom,UsedCpt
' On rcupre le compte utilisateur concern
SET USR = VBW.LastUsrDoc()
' La ligne concerne
Pos=USR.Selected
' Le libell stock en colonne 2
Lib=USR.GetData(Pos,2)
' La cl stocke
Key=USR.GetDataKey(Pos)
' On indique dans la zone dtail
USR.SetInfo 0,"Dernire modification sur : " & Lib 
Nom=USR.GetMem(1) 'Mem 1 = Cl du Cpt
' On ouvre le compte associ
Set UsedCpt = USR.AttachCpt(Nom)
' On pourrait aussi utiliser : Set UsedCpt = VBW.OpenCpt(Nom)
' mais la commande AttachCpt est plus efficace car elle conserve le compte ouvert tant que
' le compte utilisateur USR est ouvert (ie que une de ses fentre reste ouverte)
' On vas  l'criture
if not UsedCpt.ReadEcrAt(Key) then ' En cas d'erreur on annule
    UsedCpt.Close False ' On libre le compte
    USR.SetInfo 0,"Erreur modification sur : " & Lib
    USR.NotifyChange false
    Exit Sub
end if
' On transforme le nombre en texte
LibNum=UsedCpt.Ecr.ModeOpe
LibTxt=SelectLib(Nom,LibNum)
if LibNum=-1 then 
    UsedCpt.Close False ' On libre le compte
    USR.SetInfo 0,"Modification annule sur : " & Lib
    USR.NotifyChange false
    Exit Sub
end if
UsedCpt.Ecr.ModeOpe=LibNum
' On enregistre la modification de Ecr
UsedCpt.WriteEcr
' On met  jour l'enregistrement
USR.SetData Pos,0,UsedCpt.Ecr.ModeOpe
USR.SetData Pos,4,LibTxt
if LibNum=0 then USR.SetColor Pos,0 else USR.SetColor Pos,1
' On signale les changements (pas de reload le nbre d'item n'est pas modifi)
USR.NotifyChange false
' On libre le compte
UsedCpt.Close False ' Utile que si VBW.OpenCpt utilis, si AttachCpt utilis, Close sera ignor
end sub

' Slection d'un libell
Function SelectLib(CPT,NUM)
Dim P,C,X,E,S,MAX
Dim L(1,100) 
VBW.ChangeDir  ' on va de le rpertoire des comptes
SelectLib=""
X=0
MAX=0
VBW.ClearList ' On vide la ListBox
VBW.AddListItem "[Aucun libell]", -2
VBW.AddListItem "[Nouveau libell]", -1
VBW.ListSelect 0
if VBW.OpenReadFile(0,CPT & "_AL.VBW") then
  while not VBW.EndOfFile(0)
    S=VBW.ReadFile(0)
    if S<>"" then 
      P=InStr(S,"=")
      if P>1 then
        C=CInt(Left(S,P-1))
        if C>MAX then MAX=C
        E=Mid(S,P+1)
        if C>9 then S=C else S="0" & C
        VBW.AddListItem S & " - " & E, C
        L(0,X)=C
        L(1,X)=E
        if C=NUM then VBW.ListSelect X+2
        X=X+1
      end if
    end if
  wend
  VBW.CloseFile 0
end if
C=VBW.ListShow("Choisir un libell")  ' Demande  l'utilisateur de choisir
if C=-1 then NUM=-1 : Exit Function
' On rcupre la position du compte choisi
' C reprsente l'index de choix dans la ListBox
' P reprsente le n de libell
P=VBW.GetListData(C)
' On ajoute le libell si demand
if P=-1 then
    P=MAX+1
    E=InputBox("Entrez un nouveau libell :","Nouveau libell","")
    if IsEmpty(E) then NUM=-1 : Exit Function
    L(0,X)=P
    L(1,X)=E
    X=X+1
    ' On enregistre le nouveau fichier
    VBW.OpenWriteFile 0,CPT & "_AL.VBW"
    for C=0 to X-1
      VBW.WriteFile 0,L(0,C) & "=" & L(1,C)
    next
    VBW.CloseFile 0
end if
if P=-2 then NUM=0 : SelectLib="" : exit Function
NUM=P
' On cherche le bon libell  renvoyer
for C=0 to X-1
   if L(0,C)=P then SelectLib=L(1,C)
next
End Function

' Dclaration de la procdure de lancement "Go"
Sub Go()
' On dclare un menu qui lance la procdure principale 
VBW.DeleteMenu "Editer Libells Actions"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Editer Libells Actions","edtact_Run"
End Sub
