' =====================================================================
'  EXPORT : Exportation d'critures
'  Objectif :
'     Pour le compte selectionn par l'utilisateur
'     Exporte l'ensemble des critures avec ou sans sous critures
'     Utilise la fentre rsultat pour visionner la sortie
' =====================================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

' Procdure principale
Sub Export()
Dim C,P,E,CPT,D,F,A,Name
VBW.ClearList ' On vide la ListBox
P=0 ' P contient le n d'ordre du compte (index ou position)
For Each E in VBW  ' Pour chaque CptEntry 
  ' On l'ajoute dans la ListBox avec sa position P
  VBW.AddListItem E.Key & " - " & E.LongName, P
  P=P+1
next
VBW.ListSelect 0 ' Slectionne le premier compte cr dans VBW
C=VBW.ListShow("Choisir un compte")  ' Demande  l'utilisateur de choisir
if C=-1 then MsgBox "Annul" : Exit Sub
' On rcupre la position du compte choisi
' C reprsente l'index de choix dans la ListBox
' P reprsente la position (n d'ordre ou index) du compte sauvegard avec AddListItem
P=VBW.GetListData(C)
' On ouvre le compte ayant le n d'ordre (index) P
set CPT = VBW.OpenCpt(VBW.Item(P).Key)
VBW.TitleStr="Exportation de " & CPT.Entry.Key & " - " & CPT.Entry.LongName
VBW.PrintEffect=vbwNormal
if CPT.Entry.Type<>"Ecritures" and CPT.Entry.Type<>"Compte Titre" then 
    VBW.PRINT "Compte de type " & CPT.Entry.Type & "Non support"
    CPT.Close
    exit sub
end if
A=InputBox("Entre l'anne de dbut ou 0 :","Dbut","")
if A="" then CPT.Close : Exit Sub
if A>0 then D="01/01/" & A else D="00/00/00"
A=InputBox("Entre l'anne de fin ou 0 :","Fin","")
if A="" then CPT.Close : Exit Sub
if A>0 then F="31/12/" & A else F="00/00/00"
Name=VBW.FileSelect(vbwSave,"Fichier texte (*.TXT)|*.TXT|Tous (*.*)|*.*","TXT")
if Name="" then CPT.Close : Exit Sub
VBW.Print "Sauvegarde dans " & Name
if not VBW.OpenWriteFile(0,Name) then VBW.Print "Erreur d'ouverture" : CPT.Close : exit Sub
if CPT.Entry.Type="Ecritures" then TraiteCptEcr CPT,D,F
if CPT.Entry.Type="Compte Titre" then TraiteCptAct CPT,D,F
' On libre la fentre rsultat pour ne plus qu'elle soit modifie
VBW.DiscardPrintOut False ' Pas de fermerture de la fentre
CPT.Close
VBW.CloseFile 0
End Sub

' Procedure qui traite un compte Ecr pour en lire les critures et les exporter
sub TraiteCptEcr(ByRef CPT,AD,AF)
Dim S
' On ouvre un query pour les annes completes
CPT.NewQuery AD,AF,"NoPrev"
' Pour chaque criture on ajoute le montant  la catgorie
' Note : Les sous critures oblige un ajustement de l'criture principale dont
' la catgorie ne doit alors pas intgrer la totalit du montant 
while CPT.ReadNextEcr()
  if CPT.Ecr.ModeOpe=vbwModePrv or CPT.Ecr.ModeOpe=vbwModeBud then 
      ' Dans cet exemple on exporte pas les Prevision ou budgets
      VBW.Print "(!) " & CPT.Ecr.DateVal & " : " & CPT.Ecr.Text
  elseif CPT.Ecr.TypeOpe=vbwOpeSec then
      ' ni les sous ecritures....
      VBW.Print ">>> " & CPT.Ecr.DateVal & " : " & CPT.Ecr.Text
   else
      ' Ecritures normales
      VBW.Print CPT.Ecr.DateVal & " : " & CPT.Ecr.Text & " = " & CPT.Ecr.Value
      S="""" & CPT.Ecr.Key & """"
      S=S & ";""" & CPT.Ecr.DateVal & """"
      S=S & ";""" & CPT.Ecr.DateOpe & """"
      if CPT.Ecr.ModeOpe=vbwModeRel then 
        S=S & ";""X"""
      else
        S=S & ";"" """
      end if
      S=S & ";""" & CPT.Ecr.NameOpe & """"
      S=S & ";""" & CPT.Ecr.Text & """"
      S=S & ";""" & CPT.Ecr.Value & """"
      S=S & ";""" & CPT.Ecr.Cat & """"
      S=S & ";""" & CPT.Ecr.UserNum & """"
      S=S & ";""" & CPT.Ecr.LinkedEcr & """"
      S=S & ";""" & CPT.Ecr.LinkedCpt & """"
      VBW.WriteFile 0,S
   end if
wend
End Sub

' Procedure qui traite un compte Action pour en lire les critures et les exporter
sub TraiteCptAct(ByRef CPT,AD,AF)
Dim S
' On ouvre un query pour les annes completes
CPT.NewQuery AD,AF
' Pour chaque criture on ajoute le montant  la catgorie
' Note : Les sous critures oblige un ajustement de l'criture principale dont
' la catgorie ne doit alors pas intgrer la totalit du montant 
while CPT.ReadNextEcr()
    VBW.Print CPT.Ecr.DateVal & " : " & CPT.Ecr.Text & " = " & CPT.Ecr.QTE
    S="""" & CPT.Ecr.Key & """"
    S=S & ";""" & CPT.Ecr.DateVal & """"
    S=S & ";""" & CPT.Ecr.Value & """"
    S=S & ";""" & CPT.Ecr.Qte & """"
    S=S & ";""" & CPT.Ecr.UserNum & """"
    S=S & ";""" & CPT.Ecr.Text & """"
    if CPT.Ecr.ModeOpe=0 then
      S=S & ";""""" ' Pas de libell spcifique enregistr
    else
      S=S & ";""" & CPT.Ecr.NameOpe & """" ' Libell spcifique
    end if
    S=S & ";""" & CPT.Ecr.LinkedEcr & """"
    S=S & ";""" & CPT.Ecr.LinkedCpt & """"
    VBW.WriteFile 0,S
wend
End Sub


Sub Go()
VBW.DeleteMenu "Exporter un compte"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Exporter un compte","Export"
End Sub
