' ===============================================================================
'  PORTEMON : Gestion d'un compte porte monnaie
'  Objectif :
'     Pour le compte courant propose la cration d'critures dans
'     le compte porte monnaie associ (qui doit dja exister)
'     Pour rentrer plusieurs critures il faut cliquer VENTIL et pas OK
'     Vous pouvez modifier la catgorie DIVERS utilise dans le script
' ===============================================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

sub HELP_Monnaie() ' Affich si l'utilisateur demande une aide sur le menu
  MsgBox "Pour le compte courant propose la cration d'critures dans" & vbcr & _
     "le compte porte monnaie associ (qui doit dja exister)" & vbcr & _
     "Pour rentrer plusieurs critures il faut cliquer VENTIL et pas OK" & vbcr & _
     vbcr & _
     "La premire fois le compte associ sera demand  l'utilisateur. Si le" & vbcr & _
     "le compte associ est le compte d'origine alors on utilisera plutot des" & vbcr & _
     "critures de ventilation (avec montant = 0) qu'un compte associ." & vbcr & _
     vbcr & _
     "Dans tous les cas les Retraits d'espces seront  saisir avec" & vbcr & _
     "la catgorie ""Divers"" et avec l'option dcrmenter le budget" & vbcr & _
     "Si un compte porte monnaie est utilis alors tous les retraits " & vbcr & _
     "devront tre saisie sous la forme d'un virement vers le compte" & vbcr & _
     "porte monnaie associ." & vbcr & _
     vbcr & _
     "Dans le cas d'un compte porte monnaie spar, il faudra utiliser des" & vbcr & _
     "statistiques sur plusieurs comptes  l'aide de script pour tenir compte" & vbcr & _
     "de la somme des catgories dans le compte de base et le compte associ"
end sub

' Procdure principale
Sub Monnaie()
Dim CPT,PMCPT,PMCptKey,Fin,Total,DIVERS,BE
DIVERS="Divers" ' C'est la catgorie qui sera utilis comme DIVERS 
' Note : Si DIVERS="" alors la catgorie sera demande  l'utilisateur
if not IsObject(VBW.LastDoc())  then
  MsgBox "Erreur aucun compte ouvert"
  Exit sub
end if
set CPT = VBW.LastDoc()
if not CPT.Entry.Type=vbwTypeEcr then
  MsgBox "Erreur le compte " & CPT.Entry.Key & " n'est pas un compte Ecritures"
  Exit sub
end if
if DIVERS="" then DIVERS=CPT.SelectCat("Choisir une catgorie pour le porte monnaie")
if DIVERS="" then DIVERS="Divers"
SET BE=CPT.GetBudgetEntry(DIVERS)
if BE.Key="" then 
  MsgBox "Erreur le compte " & CPT.Entry.Key & " n'a pas de catgorie " & DIVERS
  Exit sub
end if
DIVERS=BE.Key ' Juste pour tre sur que la catgorie est exacte (y compris majuscules)
PMCptKey=GetPM(CPT.Entry.Key)
if PMCptKey="" then Exit Sub
' Si Porte Monnaie = Compte alors mode ventilation simple
if PMCptKey=CPT.Entry.Key then
  ' On prpare la boite de dialogue pour ventiler une pseudo criture
  CPT.EcrDialog.Reset
  CPT.EcrDialog.Write=true
  CPT.EcrDialog.EnableDecBud=true ' On pourrait aussi laisser par dfaut
  CPT.EcrDialog.DecBud=true
  CPT.EcrDialog.Preset=true
  CPT.EcrDialog.Ecr.Text="Opration en liquide (Porte Monnaie)"
  CPT.EcrDialog.Ecr.Cat=DIVERS
  CPT.EcrDialog.Ecr.Qte=-1 ' Astuce pour forcer un dbit var Value=0
  CPT.EcrDialog.Ecr.Value=0
  ' Ici on pourrait aussi dfinir DateVal et DateOpe
  CPT.EcrDialog.AutoValid=vbwBVentil ' On force la ventilation
  ' On dite l'criture (ie aprs la ventilation)
  if not CPT.EditEcrDialog(-1) then
     ' Si annulation on efface tout 
     CPT.DeleteEcr CPT.EcrDialog.MasterKey
  end if
  exit sub
end if
' On est en mode compte porte monnaie spar
set PMCPT = VBW.OpenCpt(PMCptKey)
' On prpare la boite de dialogue pour juste lire les champs
CPT.EcrDialog.Reset
CPT.EcrDialog.Write=false
' On n'autorise pas Rel (qui actif par defaut quand Write=false)
CPT.EcrDialog.DisableRel=true
' Pas de vrai ventilation donc on dsactive Suivant et Prcdent
CPT.EcrDialog.DisableVentilN=true
CPT.EcrDialog.DisableVentilP=true
' On dite l'criture (sans enregister dans la base)
Total=0
do
  Fin=true
  if CPT.EditEcrDialog(-1) then
      ' si l'utilisateur a cliqu Ok et pas Ventil alors on s'arretera
      if CPT.EcrDialog.Button=vbwBVentil then Fin=false
      ' On prpare un boite de dialogue  validation automatique
      PMCPT.EcrDialog.Reset
      PMCPT.EcrDialog.CopyEcr CPT.EcrDialog.Ecr
      PMCPT.EcrDialog.DisableDecBud=true
      PMCPT.EcrDialog.DecBud=false
      PMCPT.EcrDialog.Preset=true
      PMCPT.ImportCatFrom(CPT.Entry.Key) 
      PMCPT.EcrDialog.AutoValid=vbwBOk ' On force la validation
      if not PMCPT.EditEcrDialog(-1) then 
        Fin=true ' Anormal : opration annule finalement
      else 
        ' si l'utilisateur a activ dcrmenter le budget
        if CPT.EcrDialog.DecBud then 
           ' On dcrmente pas le porte monnaie mais le compte source
           CPT.AjustBud true,CPT.EcrDialog.Ecr.Cat,CPT.EcrDialog.Ecr.Value
           Total=Total+CPT.EcrDialog.Ecr.Value
        end if
      end if
  end if
loop until Fin
' On incrmente Divers dans le compte source pour l'ensemble des opration
if Total<>0 then CPT.AjustBud false,DIVERS,Total
PMCPT.Close False
end sub

Function GetPM(ByVal Key)
Dim PM,S,P,E,C
PM=""
' On cherche le porte monnaie associ au compte
if VBW.OpenReadFile(0, "PorteMon.txt") then
  while not VBW.EndOfFile(0)
    S=VBW.ReadFile(0)
    P=InStr(S,",")
    if P>1 then
      if StrComp(Left(S,P-1),Key,1)=0 then ' trouv sans tenir compte de la casse
        PM=mid(S,P+1)
        if StrComp(PM,Key,1)=0 then GetPM=Key : VBW.CloseFile 0: exit function
      end if
      if StrComp(mid(S,P+1),Key,1)=0 then ' trouv sans tenir compte de la casse
        MsgBox "Erreur ce compte est dja un porte monnaie de " & Left(S,P-1)
        GetPM=""
        VBW.CloseFile 0
        exit function
      end if
    end if
  wend
  VBW.CloseFile 0
end if
if PM="" then
  VBW.ClearList ' On vide la ListBox
  P=0 ' P contient le n d'ordre du compte (index ou position)
  For Each E in VBW  ' Pour chaque CptEntry 
    ' On l'ajoute dans la ListBox avec sa position P si c'est un compte Ecritures
    if E.Type=vbwTypeEcr then VBW.AddListItem E.Key & " - " & E.LongName, P
    P=P+1
  next
  VBW.ListSelect 0 ' Slectionne le premier compte cr dans VBW
  C=VBW.ListShow("Choisir un compte porte monnaie pour " & Key)  ' Demande  l'utilisateur de choisir
  if C=-1 then GetPM="" : MsgBox "Opration Annule" : Exit function
  P=VBW.GetListData(C)
  PM = VBW.Item(P).Key
  VBW.OpenWriteFile 0, "PorteMon.txt", true
  VBW.WriteFile 0,Key & "," & PM
  VBW.CloseFile 0
end if
GetPM=PM
end function

Sub Go()
VBW.DeleteMenu "Porte Monnaie"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Porte Monnaie","Monnaie"
End Sub
