' ==============================================================
'  RESUME : Ce script permet d'avoir un rsum des comptes avec
'     posibilit de statistiques graphiques
' ==============================================================
'    Auteur : Patrick Bory
'    Rvision : 1 

' Au chargement de la macro on execute la procedure Go
#RUN=Go

' Oblige une dclaration explicite des variables pour viter les erreurs
option Explicit

' Dclaration de la procdure principale "Test"
Sub ResCpt()
Dim USR
SET USR=VBW.NewUsrCpt()
USR.SetHeader 0,28,"S", vbwColSymbol
USR.SetHeader 1,80,"Cpt"
USR.SetHeader 2,100,"Nom dtaill",vbwColLeft
USR.SetHeader 3,90,"Solde", vbwColRight
USR.SetHeader 4,90,"Solde Prev", vbwColRight
USR.TitleStr="Liste des comptes"
' On indique que la zone dtails (infos) doti tre affiche
USR.ShowDetails=True
' On prcise Sub en cas de clic sur 1ere colonne
USR.SubCheck="Res_Check"
' On indique la procedure pour afficher le graphique
USR.SubGraphic="Res_Graph"
' On prcise que en cas de demande de raffraichissmeent il faut appeller Updt
USR.SubRefresh="Res_Updt"
' On indique un Menu d'activation avec sa macro "Open"
USR.SubActivate="Res_Open"
USR.MenuActivate="Ouvrir le compte"
USR.AutoSizeHdr=2  ' La colonne 2 sera ajuste selon la taille de la fentre
Res_Reload USR
' On affiche la fentre rsultat
USR.ShowView
' On libre le compte Utilisateur ce qui fermera le compte quand il n'y aura plus de vue ouverte
USR.Close
End sub

sub Res_Reload(byref USR)
Dim E,Cpt,Pos
USR.SetMem 0,"0" ' Total des lignes selectionnes
USR.SetInfo 0,"Total des comptes slectionns = 0.00"
For Each E in VBW  ' Pour chaque CptEntry 
  ' On l'ajoute dans la ListBox avec sa position P si c'est un compte Ecritures
  if E.Type=vbwTypeEcr or E.Type=vbwTypeAct then 
    Pos=USR.AddData(0)
    USR.SetData Pos,1,E.Key
    USR.SetData Pos,2,E.LongName
    Set Cpt = VBW.OpenCpt(E.Key)
    if E.Type=vbwTypeEcr then
      USR.SetData Pos,0,vbwSymbolBox
      USR.SetData Pos,3,VBW.FormatNumber(Cpt.GetSolde(vbwSoldeToday))
      USR.SetData Pos,4,VBW.FormatNumber(Cpt.GetSolde(vbwSoldeEndPrv))
    else
      USR.SetData Pos,0,""
      USR.SetData Pos,3,VBW.FormatNumber(Cpt.GetSolde(vbwSoldeValue))
      USR.SetData Pos,4,""
    end if
    Cpt.Close
  end if
next
end sub

' Procedure appelle lors d'un clic en 1ere colonne
sub Res_Check()
Dim USR,Pos,Total,Mont
' On rcupre le compte utilisaeur en cours
Set USR=VBW.LastUsrDoc
Pos=USR.Selected ' Ligne clique
Total=CSng(USR.GetMem(0))
Mont=VBW.EvalNumber(USR.GetData(Pos,3))
if USR.CheckItem = vbwSymbolBox then 
  USR.CheckItem = vbwSymbolCheckBox
  Total=Total+Mont
else  
  if USR.CheckItem = vbwSymbolCheckBox then 
      USR.CheckItem = vbwSymbolBox
      Total=Total-Mont
  end if
end if
USR.SetInfo 0,"Total des comptes slectionns = " & VBW.FormatNumber(Total)
USR.SetMem 0,Total ' Total des lignes selectionnes
USR.NotifyChange false
end sub

' Procedure qui sera appelle si l'utilisateur demande une mise  jour de l'affichage
sub Res_Updt()
Dim USR
' On rcupre le compte utilisaeur en cours
Set USR=VBW.LastUsrDoc
' Ici on pourrait sauvegarder dans un tableau les comptes selectionns pour les
' reselectionner aprs mise  jour. Pour l'instant la slection est perdue.
USR.Purge ' On supprimer toutes les donnes
' On insre tous les items
Res_Reload USR
' On signale les modifications
USR.NotifyChange True
end sub

sub Res_Open()
Dim Pos,Key,USR,Cpt
' On rcupre le compte utilisateur concern
SET USR = VBW.LastUsrDoc()
' La ligne concerne
Pos=USR.Selected
' La cl stocke en colonne 1
Key=USR.GetData(Pos,1)
' On ouvre le compte
Set Cpt = VBW.OpenCpt(Key)
Cpt.ShowView vbwViewNormal
' On libre le compte sans fermer la vue
Cpt.Close
end sub

sub Res_Graph()
Dim USR,Cpt,N,I,Min,Max,Scale,Total,Last,R,V,B
Dim Gr() ' Tableau dynamique
' On rcupre le compte utilisateur concern
SET USR = VBW.LastUsrDoc()
ReDim Gr(2,USR.Count)
N=0 : Max=0 : Min=0
for I=0 to USR.Count
   if USR.GetData(I,0)=vbwSymbolCheckBox then
      N=N+1
      Gr(1,N)=USR.GetData(I,1)
      Gr(2,N)=VBW.EvalNumber(USR.GetData(I,3))
      if Gr(2,N)<Min then Min=Gr(2,N)
      if Gr(2,N)>Max then Max=Gr(2,N)
      if Gr(2,N)>0 then Total=Total+Gr(2,N)
   end if
next
if N=0 then MsgBox "Auncun compte slectionn" : Exit Sub
Scale=GraphInit(N,Min,Max,Total)
Last=0
for I=1 to N
  Color I,R,V,B
  if Gr(2,I)>0 then 
    VBW.GraphDraw vbwBrush,R,V,B,vbwBrushSolid ' Brosse pleine Bleu
  else
    VBW.GraphDraw vbwBrush,R,V,B,vbwBrushDiagcross ' Brosse hacure
  end if
  GraphHist N,Scale,Max,I,Gr(2,I),Gr(1,I)
  GraphCam Last,Gr(2,I),Gr(1,I),Total
next
end sub

Sub Color(C,R,V,B)
  R=Int(256*Rnd)
  V=Int(256*Rnd)
  B=Int(256*Rnd)
  select case C
    case 1 R=128:V=0:B=0
    case 2 R=0:V=128:B=0
    case 3 R=0:V=0:B=128
    case 4 R=128:V=255:B=128
    case 5 R=128:V=0:B=255
    case 6 R=128:V=255:B=255
    case 7 R=255:V=128:B=0
    case 8 R=255:V=0:B=128
    case 9 R=255:V=128:B=128
  end select
end sub


' ==================================== Outils Graphiques ==================================
const ResGSpc=5, ResGLarg=40, ResHLine=50

' Init Graph and return Scale for Value
function GraphInit(N,Min,Max,Total)
Dim Scale,I
VBW.GraphClear true
Scale=0
if Max<>Min then Scale=1000/(Max-Min)
VBW.SetGraphZone ResGLarg*N+100,1000+ResHLine
VBW.GraphDraw vbwColor,0,0,0,vbwZCenter+vbwZVCenter 'Plume noire et texte centr
VBW.GraphDraw vbwPen,1,vbwPenDot,vbwNoScale 'Plume pointill de 1 pixel
I=CInt(Min/100)*100
while I<Max
  VBW.GraphDraw vbwLine,0,CInt((Max-I)*Scale),ResGLarg*N,CInt((Max-I)*Scale)
  I=I+100
wend
VBW.GraphDraw vbwPen,1,vbwPenSolid,vbwNoScale 'Plume pleine de 1 pixel
VBW.GraphDraw vbwFont,ResHLine/2,0,0,0,"Arial"
I=CInt(Min/1000)*1000
while I<Max
  VBW.GraphDraw vbwLine,0,CInt((Max-I)*Scale),ResGLarg*N,CInt((Max-I)*Scale)
  VBW.GraphDraw vbwText,ResGLarg*N+1,CInt((Max-I)*Scale)-ResHLine/4,0,0,I
  I=I+1000
wend
VBW.GraphDraw vbwPen,2,vbwPenSolid,vbwNoScale 'Plume pleine de 1 pixel
VBW.GraphDraw vbwLine,0,CInt(Max*Scale),ResGLarg*N,CInt(Max*Scale)
VBW.GraphDraw vbwPen,1,vbwPenSolid,vbwNoScale 'Plume pleine de 1 pixel
VBW.GraphDraw vbwSetPieSqr,ResGLarg*N+20,300,ResGLarg*N+80
GraphInit=Scale
end function

sub GraphHist(N,Scale,Max,Pos,Value,Text)
dim X1,X2
VBW.GraphDraw vbwFont,ResHLine-3,(ResGLarg-2*ResGSpc)/10,0,0,"Arial"
X1=(Pos-1)*ResGLarg+ResGSpc
X2=(Pos)*ResGLarg-ResGSpc
VBW.GraphDraw vbwFillRect,X1,CInt(Max*Scale),X2,CInt((Max-Value)*Scale)
VBW.GraphDraw vbwTextZone,X1,1005,X2,1000+ResHLine,Text
end sub

sub GraphCam(Last,Value,Text,Total)
dim X
if Value>0 then
  VBW.GraphDraw vbwFont,0,0,0,0,"Arial" ' Automatique
'  VBW.GraphDraw vbwFont,ResHLine-8,0,0,0,"Arial"
  X=Last+CInt((Value/Total)*100)
  if X<>Last then VBW.GraphDraw vbwPieP,Last,X,0,0, X-Last & "%"
  Last=X
end if
end sub

' ==================================== ==================================

' Dclaration de la procdure de lancement "Go"
Sub Go()
' On dclare un menu Test qui lance la procdure principale "Test"
VBW.DeleteMenu "Rsum des comptes"      ' Pour viter un doublon si rechargement
VBW.AddMenu "Rsum des comptes","ResCpt"
End Sub
